var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import React from 'react';
import { A11y, Autoplay, Controller, EffectCoverflow, EffectCube, EffectFade, EffectFlip, EffectCreative, EffectCards, HashNavigation, History, Keyboard, Lazy, Mousewheel, Navigation, Pagination, Parallax, Scrollbar, Thumbs, Virtual, Zoom, FreeMode, Grid, Manipulation, } from 'swiper';
import 'swiper/css/bundle';
import { Swiper, SwiperSlide } from 'swiper/react';
import { LeftOutlined, RightOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { useComponentConfig, usePrefixConfig } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DSlidesSlide } from './SlidesSlide';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DSlides' });
export const DSlides = (props) => {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, navigation: _navigation, pagination: _pagination, direction = 'horizontal' } = _a, restProps = __rest(_a, ["children", "navigation", "pagination", "direction"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const navigation = (() => {
        const configs = {
            nextEl: '.swiper-button-next',
            prevEl: '.swiper-button-prev',
        };
        if (_navigation === true || isUndefined(_navigation)) {
            return configs;
        }
        if (_navigation !== false) {
            return Object.assign(configs, _navigation);
        }
        return _navigation;
    })();
    const pagination = (() => {
        const configs = {
            clickable: true,
        };
        if (_pagination === true || isUndefined(_pagination)) {
            return configs;
        }
        if (_pagination !== false) {
            return Object.assign(configs, _pagination);
        }
        return _pagination;
    })();
    return (_jsxs(Swiper, Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}slides`, {
            [`${dPrefix}slides--vertical`]: direction === 'vertical',
        }), direction: direction, modules: [
            A11y,
            Autoplay,
            Controller,
            EffectCoverflow,
            EffectCube,
            EffectFade,
            EffectFlip,
            EffectCreative,
            EffectCards,
            HashNavigation,
            History,
            Keyboard,
            Lazy,
            Mousewheel,
            Navigation,
            Pagination,
            Parallax,
            Scrollbar,
            Thumbs,
            Virtual,
            Zoom,
            FreeMode,
            Grid,
            Manipulation,
        ], navigation: navigation, pagination: pagination }, { children: [React.Children.map(children, (child) => React.isValidElement(child)
                ? React.createElement(SwiperSlide, Object.assign(Object.assign({}, child.props), { className: getClassName(child.props.className, `${dPrefix}slide`) }))
                : child), _jsx("button", Object.assign({ className: "swiper-button-prev" }, { children: _jsx(LeftOutlined, {}) })), _jsx("button", Object.assign({ className: "swiper-button-next" }, { children: _jsx(RightOutlined, {}) }))] })));
};
DSlides.Slide = DSlidesSlide;
//# sourceMappingURL=Slides.js.map