var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DEmpty } from '../empty';
import { DTableTd } from './TableTd';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DTable.Empty' });
export function DTableEmpty(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dColSpan } = _a, restProps = __rest(_a, ["children", "dColSpan"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    return (_jsx("tr", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}table__empty`) }, { children: _jsx(DTableTd, Object.assign({ className: `${dPrefix}table__empty-content`, colSpan: dColSpan, dAlign: "center" }, { children: checkNodeExist(children) ? children : _jsx(DEmpty, {}) })) })));
}
//# sourceMappingURL=TableEmpty.js.map