/// <reference types="react" />
export interface DFocusVisibleRenderProps {
    fvOnFocus: React.FocusEventHandler;
    fvOnBlur: React.FocusEventHandler;
    fvOnKeyDown: React.KeyboardEventHandler;
}
export interface DFocusVisibleProps {
    children: (props: DFocusVisibleRenderProps) => JSX.Element | null;
    onFocusVisibleChange?: (visible: boolean) => void;
}
export declare function DFocusVisible(props: DFocusVisibleProps): JSX.Element | null;
