import React from 'react';
export declare type DBreakpoints = 'xs' | 'sm' | 'md' | 'lg' | 'xl' | 'xxl';
export interface DRowContextData {
    gMediaMatch: DBreakpoints[];
    gSpace: number | string;
}
export declare const DRowContext: React.Context<DRowContextData | null>;
export declare type DGutterValue = number | string | [number | string, number | string];
export interface DRowProps extends React.HTMLAttributes<HTMLDivElement> {
    dGutter?: DGutterValue;
    dResponsiveGutter?: Record<DBreakpoints, DGutterValue>;
}
export declare function DRow(props: DRowProps): JSX.Element | null;
