import React from 'react';
export interface DCellProps extends React.TdHTMLAttributes<HTMLTableCellElement> {
    dTag: 'th' | 'td';
    dWidth?: number | string;
    dFixed?: {
        top?: number | string;
        right?: number | string;
        bottom?: number | string;
        left?: number | string;
    };
    dAlign?: 'left' | 'right' | 'center';
    dEllipsis?: boolean;
}
export declare function DCell(props: DCellProps): JSX.Element | null;
